﻿using System;
using System.Collections.Generic;

namespace GenericLibrary
{
    public interface ICatalog<TId, TElement> : IEnumerable<TElement> where TElement : IIdentifiable<TId>
    {
        /// <summary>
        /// No duplicates
        /// </summary>
        /// <param name="element"></param>
        /// <returns></returns>
        bool Add(TElement element);
        int Count { get; }
        TElement Find(TId id);
        IEnumerable<TElement> GetAll();
        IReadOnlyCollection<TElement> GetAll2();
        IEnumerable<TElement> GetAll(Predicate<TElement> predicate);
        string ToString();
    }
}
